-- The default rotations generator for DEATHKNIGHT.
local deathKnightRotationsGenerator = function ()
  local rotation = {
    ["defaultRotation/deathKnight/blood"] = {
      ["ActionList"] = {
        ["defaultRotation/deathKnight/unholy_blight"] = {
          ["v_t_needsdebuff"] = "_55095&_55078",
          ["b_t_dr"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "115989",
          ["b_t_needsdebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "111673",
          ["v_actionicon"] = "115989",
        },
        ["defaultRotation/deathKnight/death_strike_frost_unholy"] = {
          ["b_p_frostrunes"] = true,
          ["v_keybind"] = "<keybind>",
          ["b_p_unholyrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["v_togglename"] = "Toggle 1",
          ["v_p_hp"] = "<90%",
          ["v_p_unholyrunes"] = "=2",
          ["v_actionicon"] = "49998",
          ["v_spellname"] = "49998",
          ["v_p_frostrunes"] = "=2",
          ["b_p_hp"] = true,
          ["v_durationstartedtime"] = 0,
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/plague_leech_blood"] = {
          ["v_t_needsdebuff"] = "_55095^4&_55078^4",
          ["b_p_bloodrunes"] = true,
          ["v_actionicon"] = "123693",
          ["b_rangecheck"] = true,
          ["v_gcdspell"] = "111673",
          ["v_keybind"] = "<keybind>",
          ["b_checkothercd"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "123693",
          ["b_t_needsdebuff"] = true,
          ["v_checkothercdvalue"] = "<1",
          ["v_p_bloodrunes"] = "=0",
          ["v_checkothercdname"] = "77575",
        },
        ["defaultRotation/deathKnight/horn_of_winter"] = {
          ["v_p_needbuff"] = "57330|19506|6673",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "57330",
          ["v_spellname"] = "57330",
          ["b_p_needbuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "111673",
          ["v_durationstartedtime"] = 0,
        },
        ["defaultRotation/deathKnight/Lichborne"] = {
          ["v_actionicon"] = "49039",
          ["v_p_hp"] = "<50%",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "49039",
          ["v_togglename"] = "Toggle 1",
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "0",
          ["b_p_hp"] = true,
        },
        ["defaultRotation/deathKnight/Blood_Tap_Frost_Life"] = {
          ["b_p_frostrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_gcdspell"] = "0",
          ["v_p_frostrunes"] = "=0",
          ["b_p_havebuff"] = true,
          ["v_p_hp"] = "<80%",
          ["v_actionicon"] = "45529",
          ["v_spellname"] = "45529",
          ["v_durationstartedtime"] = 0,
          ["b_p_hp"] = true,
          ["v_p_havebuff"] = "_114851#5",
          ["v_keybind"] = "<keybind>",
        },
        ["defaultRotation/deathKnight/horn_of_winter_power"] = {
          ["v_gcdspell"] = "111673",
          ["b_p_unitpower"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "57330",
          ["v_p_unitpowertype"] = "6",
          ["v_keybind"] = "<keybind>",
          ["v_p_unitpower"] = "<80",
          ["v_actionicon"] = "57330",
        },
        ["defaultRotation/deathKnight/Vampiric_Blood"] = {
          ["v_actionicon"] = "55233",
          ["v_p_hp"] = "<70%",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "55233",
          ["v_togglename"] = "Toggle 1",
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "0",
          ["b_p_hp"] = true,
        },
        ["defaultRotation/deathKnight/Soul_Reaper"] = {
          ["b_p_bloodrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["b_rangecheck"] = true,
          ["v_actionicon"] = "114866",
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "114866",
          ["b_t_hp"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_p_bloodrunes"] = ">=1",
          ["v_t_hp"] = "<=35%",
        },
        ["defaultRotation/deathKnight/Plague_Strike"] = {
          ["v_t_needsdebuff"] = "_55078",
          ["b_t_hasdebuff"] = true,
          ["b_p_unholyrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["b_rangecheck"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_p_unholyrunes"] = ">=1",
          ["v_actionicon"] = "45462",
          ["v_spellname"] = "45462",
          ["b_t_needsdebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_durationstartedtime"] = 0,
          ["v_t_hasdebuff"] = "_55095",
        },
        ["defaultRotation/deathKnight/IcyTouch"] = {
          ["v_t_needsdebuff"] = "_55095",
          ["b_p_frostrunes"] = true,
          ["b_p_unholyrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["v_durationstartedtime"] = 0,
          ["v_togglename"] = "Toggle 1",
          ["v_p_unholyrunes"] = ">=1",
          ["v_actionicon"] = "45477",
          ["v_spellname"] = "45477",
          ["b_t_needsdebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_p_frostrunes"] = ">=1",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/BloodTap_Blood"] = {
          ["b_p_bloodrunes"] = true,
          ["v_gcdspell"] = "0",
          ["v_p_havebuff"] = "_114851#10",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "45529",
          ["v_spellname"] = "45529",
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
          ["v_p_bloodrunes"] = "=0",
          ["b_p_havebuff"] = true,
        },
        ["defaultRotation/deathKnight/RuneTap"] = {
          ["b_p_bloodrunes"] = true,
          ["v_gcdspell"] = "0",
          ["v_togglename"] = "Toggle 1",
          ["v_p_hp"] = "<80%",
          ["v_actionicon"] = "48982",
          ["v_spellname"] = "48982",
          ["v_durationstartedtime"] = 0,
          ["b_p_hp"] = true,
          ["v_p_bloodrunes"] = ">=1",
          ["v_keybind"] = "<keybind>",
        },
        ["defaultRotation/deathKnight/conversion"] = {
          ["v_p_needbuff"] = "_119975",
          ["b_p_needbuff"] = true,
          ["v_p_hp"] = "<70%",
          ["v_actionicon"] = "119975",
          ["v_spellname"] = "119975",
          ["v_togglename"] = "Toggle 1",
          ["b_p_hp"] = true,
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
        },
        ["defaultRotation/deathKnight/DeathSiphon"] = {
          ["v_p_deathrunes"] = ">=1",
          ["b_p_deathrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["v_keybind"] = "<keybind>",
          ["v_p_hp"] = "<90%",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "108196",
          ["v_togglename"] = "Toggle 1",
          ["b_p_hp"] = true,
          ["v_actionicon"] = "108196",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/DeathStrike_Death"] = {
          ["v_p_deathrunes"] = ">=2",
          ["b_p_deathrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["v_keybind"] = "<keybind>",
          ["v_p_hp"] = "<90%",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "49998",
          ["v_togglename"] = "Toggle 1",
          ["b_p_hp"] = true,
          ["v_actionicon"] = "49998",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/BloodTap_Unholy_Life"] = {
          ["v_togglename"] = "Toggle 1",
          ["b_p_unholyrunes"] = true,
          ["v_gcdspell"] = "0",
          ["v_p_hp"] = "<80%",
          ["v_actionicon"] = "45529",
          ["v_p_unholyrunes"] = "=0",
          ["b_p_havebuff"] = true,
          ["v_spellname"] = "45529",
          ["v_durationstartedtime"] = 0,
          ["b_p_hp"] = true,
          ["v_p_havebuff"] = "_114851#5",
          ["v_keybind"] = "<keybind>",
        },
        ["defaultRotation/deathKnight/EmpowerRuneWeapon"] = {
          ["b_p_frostrunes"] = true,
          ["b_p_unholyrunes"] = true,
          ["v_gcdspell"] = "0",
          ["v_togglename"] = "Toggle 1",
          ["v_p_hp"] = "<60%",
          ["v_p_unholyrunes"] = "=0",
          ["v_actionicon"] = "47568",
          ["v_spellname"] = "47568",
          ["v_p_frostrunes"] = "=0",
          ["b_p_hp"] = true,
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
        },
        ["defaultRotation/deathKnight/Outbreak"] = {
          ["v_t_needsdebuff"] = "_55095&_55078",
          ["v_gcdspell"] = "111673",
          ["v_keybind"] = "<keybind>",
          ["v_togglename"] = "Toggle 1",
          ["v_p_knownotspell"] = "59332",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "77575",
          ["b_t_needsdebuff"] = true,
          ["b_p_knownotspell"] = true,
          ["v_actionicon"] = "77575",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/DeathStrike"] = {
          ["b_p_frostrunes"] = true,
          ["v_keybind"] = "<keybind>",
          ["b_p_unholyrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["v_togglename"] = "Toggle 1",
          ["v_p_hp"] = "<80%",
          ["v_p_unholyrunes"] = ">=1",
          ["v_actionicon"] = "49998",
          ["v_spellname"] = "49998",
          ["v_p_frostrunes"] = ">=1",
          ["b_p_hp"] = true,
          ["v_durationstartedtime"] = 0,
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/DeathAndDecay"] = {
          ["v_gcdspell"] = "111673",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "43265",
          ["v_spellname"] = "43265",
          ["b_p_havebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_81141",
          ["v_durationstartedtime"] = 0,
        },
        ["defaultRotation/deathKnight/BloodTap_Unholy"] = {
          ["v_gcdspell"] = "0",
          ["b_p_unholyrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_p_unholyrunes"] = "=0",
          ["v_actionicon"] = "45529",
          ["v_spellname"] = "45529",
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_114851#10",
          ["b_p_havebuff"] = true,
        },
        ["defaultRotation/deathKnight/DeathCoil_Lichborn"] = {
          ["b_p_havebuff"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_p_unitpower"] = ">=40",
          ["v_gcdspell"] = "111673",
          ["b_p_unitpower"] = true,
          ["v_actionicon"] = "47541",
          ["v_p_hp"] = "<100%",
          ["v_p_unitpowertype"] = "6",
          ["v_spellname"] = "47541",
          ["v_durationstartedtime"] = 0,
          ["b_p_hp"] = true,
          ["v_p_havebuff"] = "_49039",
          ["v_keybind"] = "<keybind>",
        },
        ["defaultRotation/deathKnight/BloodTap_Blood_Life"] = {
          ["b_p_bloodrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_gcdspell"] = "0",
          ["b_p_havebuff"] = true,
          ["v_p_havebuff"] = "_114851#5",
          ["v_p_hp"] = "<80%",
          ["v_actionicon"] = "45529",
          ["v_spellname"] = "45529",
          ["v_durationstartedtime"] = 0,
          ["b_p_hp"] = true,
          ["v_p_bloodrunes"] = "=0",
          ["v_keybind"] = "<keybind>",
        },
        ["defaultRotation/deathKnight/BloodTap_Frost"] = {
          ["b_p_frostrunes"] = true,
          ["v_gcdspell"] = "0",
          ["b_p_havebuff"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "45529",
          ["v_spellname"] = "45529",
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_114851#10",
          ["v_p_frostrunes"] = "=0",
        },
        ["defaultRotation/deathKnight/SoulReaper_Blood"] = {
          ["b_p_bloodrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["b_rangecheck"] = true,
          ["v_actionicon"] = "114866",
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "114866",
          ["b_t_hp"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_p_bloodrunes"] = "=2",
          ["v_t_hp"] = "<=35%",
        },
        ["defaultRotation/deathKnight/RaiseDead"] = {
          ["v_actionicon"] = "46584",
          ["v_p_hp"] = "<35%",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "46584",
          ["v_togglename"] = "Toggle 1",
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "111673",
          ["b_p_hp"] = true,
        },
        ["defaultRotation/deathKnight/DeathPact"] = {
          ["v_actionicon"] = "48743",
          ["v_p_hp"] = "<35%",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "48743",
          ["v_togglename"] = "Toggle 1",
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "0",
          ["b_p_hp"] = true,
        },
        ["defaultRotation/deathKnight/PlagueLeech_Frost_Unholy"] = {
          ["v_t_needsdebuff"] = "_55095^4&_55078^4",
          ["b_p_frostrunes"] = true,
          ["v_p_deathrunes"] = "<4",
          ["v_gcdspell"] = "111673",
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "123693",
          ["b_t_needsdebuff"] = true,
          ["v_checkothercdvalue"] = "<1",
          ["v_checkothercdname"] = "77575",
          ["b_p_deathrunes"] = true,
          ["b_checkothercd"] = true,
          ["v_p_unholyrunes"] = "=0",
          ["v_actionicon"] = "123693",
          ["b_p_unholyrunes"] = true,
          ["v_keybind"] = "<keybind>",
          ["b_rangecheck"] = true,
          ["v_p_frostrunes"] = "=0",
        },
        ["defaultRotation/deathKnight/BoneShield"] = {
          ["v_p_needbuff"] = "_49222",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "49222",
          ["v_spellname"] = "49222",
          ["b_p_needbuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "0",
          ["v_durationstartedtime"] = 0,
        },
        ["defaultRotation/deathKnight/Outbreak_Glyph"] = {
          ["v_t_needsdebuff"] = "_55095&_55078",
          ["v_p_unitpowertype"] = "6",
          ["v_p_knowspell"] = "59332",
          ["b_p_unitpower"] = true,
          ["v_gcdspell"] = "111673",
          ["v_actionicon"] = "77575",
          ["b_p_knowspell"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "77575",
          ["b_t_needsdebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_p_unitpower"] = ">=40",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/BloodPresence"] = {
          ["v_p_notstance"] = "1",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "48263",
          ["v_spellname"] = "48263",
          ["b_p_notstance"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "111673",
          ["v_durationstartedtime"] = 0,
        },
      },
      ["SortedActions"] = {
        "defaultRotation/deathKnight/DeathCoil_Lichborn", -- [1]
        "defaultRotation/deathKnight/BloodPresence", -- [2]
        "defaultRotation/deathKnight/horn_of_winter", -- [3]
        "defaultRotation/deathKnight/Vampiric_Blood", -- [4]
        "defaultRotation/deathKnight/BoneShield", -- [5]
        "defaultRotation/deathKnight/RaiseDead", -- [6]
        "defaultRotation/deathKnight/DeathPact", -- [7]
        "defaultRotation/deathKnight/EmpowerRuneWeapon", -- [8]
        "defaultRotation/deathKnight/Lichborne", -- [9]
        "defaultRotation/deathKnight/conversion", -- [10]
        "defaultRotation/deathKnight/BloodTap_Blood", -- [11]
        "defaultRotation/deathKnight/BloodTap_Frost", -- [12]
        "defaultRotation/deathKnight/BloodTap_Unholy", -- [13]
        "defaultRotation/deathKnight/BloodTap_Blood_Life", -- [14]
        "defaultRotation/deathKnight/Blood_Tap_Frost_Life", -- [15]
        "defaultRotation/deathKnight/BloodTap_Unholy_Life", -- [16]
        "defaultRotation/deathKnight/unholy_blight", -- [17]
        "defaultRotation/deathKnight/Outbreak", -- [18]
        "defaultRotation/deathKnight/Outbreak_Glyph", -- [19]
        "defaultRotation/deathKnight/PlagueLeech_Frost_Unholy", -- [20]
        "defaultRotation/deathKnight/plague_leech_blood", -- [21]
        "defaultRotation/deathKnight/IcyTouch", -- [23]
        "defaultRotation/deathKnight/Plague_Strike", -- [24]
        "defaultRotation/deathKnight/death_strike_frost_unholy", -- [25]
        "defaultRotation/deathKnight/DeathSiphon", -- [26]
        "defaultRotation/deathKnight/DeathStrike_Death", -- [27]
        "defaultRotation/deathKnight/RuneTap", -- [28]
        "defaultRotation/deathKnight/SoulReaper_Blood", -- [29]
        "defaultRotation/deathKnight/DeathAndDecay", -- [32]
        "defaultRotation/deathKnight/DeathStrike", -- [34]
        "defaultRotation/deathKnight/Soul_Reaper", -- [35]
        "defaultRotation/deathKnight/horn_of_winter_power", -- [37]
      },
      ["keybind"] = "<keybind>",
    },
    ["defaultRotation/deathKnight/frost_1_handed"] = {
      ["ActionList"] = {
        ["defaultRotation/deathKnight/unholy_blight"] = {
          ["v_t_needsdebuff"] = "_55095&_55078",
          ["b_t_dr"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "115989",
          ["b_t_needsdebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "111673",
          ["v_actionicon"] = "115989",
        },
        ["defaultRotation/deathKnight/HowlingBlast_Rime"] = {
          ["v_gcdspell"] = "111673",
          ["v_durationstartedtime"] = 0,
          ["v_togglename"] = "Toggle 1",
          ["b_p_havebuff"] = true,
          ["v_spellname"] = "49184",
          ["v_actionicon"] = "49184",
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_59052",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/PlagueLeech_Unholy"] = {
          ["v_t_needsdebuff"] = "_55095^4&_55078^4",
          ["v_gcdspell"] = "111673",
          ["v_p_deathrunes"] = "<6",
          ["b_p_unholyrunes"] = true,
          ["b_rangecheck"] = true,
          ["v_togglename"] = "Toggle 1",
          ["b_p_deathrunes"] = true,
          ["v_keybind"] = "<keybind>",
          ["b_checkothercd"] = true,
          ["v_p_unholyrunes"] = "=0",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "123693",
          ["b_t_needsdebuff"] = true,
          ["v_checkothercdvalue"] = "<1",
          ["v_actionicon"] = "123693",
          ["v_checkothercdname"] = "77575",
        },
        ["defaultRotation/deathKnight/horn_of_winter"] = {
          ["v_p_needbuff"] = "57330|19506|6673",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "57330",
          ["v_spellname"] = "57330",
          ["b_p_needbuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "111673",
          ["v_durationstartedtime"] = 0,
        },
        ["defaultRotation/deathKnight/Lichborne"] = {
          ["v_actionicon"] = "49039",
          ["v_p_hp"] = "<50%",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "49039",
          ["v_togglename"] = "Toggle 1",
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "0",
          ["b_p_hp"] = true,
        },
        ["defaultRotation/deathKnight/DeathAndDecay"] = {
          ["v_togglename"] = "Toggle 1",
          ["v_p_unholyrunes"] = "=2",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "43265",
          ["b_p_unholyrunes"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "111673",
          ["v_actionicon"] = "43265",
        },
        ["defaultRotation/deathKnight/HowlingBlast"] = {
          ["b_p_frostrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "49184",
          ["v_actionicon"] = "49184",
          ["v_p_frostrunes"] = ">=1",
          ["v_keybind"] = "<keybind>",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/Obliterate_Machine_Death"] = {
          ["v_gcdspell"] = "111673",
          ["v_p_deathrunes"] = ">=1",
          ["b_t_hasdebuff"] = true,
          ["b_p_unholyrunes"] = true,
          ["b_rangecheck"] = true,
          ["b_p_deathrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "49020",
          ["v_p_unholyrunes"] = "=2",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "49020",
          ["b_p_havebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_51124",
          ["v_t_hasdebuff"] = "_55095^2&_55078^2",
        },
        ["defaultRotation/deathKnight/Obliterate_Machine"] = {
          ["b_p_frostrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["b_t_hasdebuff"] = true,
          ["b_p_unholyrunes"] = true,
          ["b_rangecheck"] = true,
          ["v_gcdspell"] = "111673",
          ["v_durationstartedtime"] = 0,
          ["v_p_frostrunes"] = ">=1",
          ["v_p_unholyrunes"] = "=2",
          ["v_actionicon"] = "49020",
          ["v_spellname"] = "49020",
          ["b_p_havebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_51124",
          ["v_t_hasdebuff"] = "_55095^2&_55078^2",
        },
        ["defaultRotation/deathKnight/HowlingBlast_Death"] = {
          ["v_p_deathrunes"] = ">=1",
          ["b_p_deathrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "49184",
          ["v_spellname"] = "49184",
          ["v_gcdspell"] = "111673",
          ["v_keybind"] = "<keybind>",
          ["v_durationstartedtime"] = 0,
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/PlagueLeech_Frost"] = {
          ["v_t_needsdebuff"] = "_55095^4&_55078^4",
          ["b_p_frostrunes"] = true,
          ["v_p_deathrunes"] = "<6",
          ["v_gcdspell"] = "111673",
          ["b_rangecheck"] = true,
          ["v_p_frostrunes"] = "=0",
          ["b_p_deathrunes"] = true,
          ["v_keybind"] = "<keybind>",
          ["b_checkothercd"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "123693",
          ["b_t_needsdebuff"] = true,
          ["v_checkothercdvalue"] = "<1",
          ["v_actionicon"] = "123693",
          ["v_checkothercdname"] = "77575",
        },
        ["defaultRotation/deathKnight/Plague_Strike"] = {
          ["v_t_needsdebuff"] = "_55078",
          ["v_checkothercdname"] = "77575",
          ["b_p_unholyrunes"] = true,
          ["b_t_hasdebuff"] = true,
          ["b_rangecheck"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_gcdspell"] = "111673",
          ["v_actionicon"] = "45462",
          ["b_checkothercd"] = true,
          ["v_p_unholyrunes"] = ">=1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "45462",
          ["b_t_needsdebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_checkothercdvalue"] = ">5",
          ["v_t_hasdebuff"] = "_55095",
        },
        ["defaultRotation/deathKnight/SoulReaper_Frost"] = {
          ["b_p_frostrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["b_rangecheck"] = true,
          ["v_actionicon"] = "130735",
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "130735",
          ["b_t_hp"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_p_frostrunes"] = ">=1",
          ["v_t_hp"] = "<=35%",
        },
        ["defaultRotation/deathKnight/PlagueLeech_Death"] = {
          ["v_t_needsdebuff"] = "_55095^4&_55078^4",
          ["v_p_deathrunes"] = "<2",
          ["v_gcdspell"] = "111673",
          ["b_rangecheck"] = true,
          ["b_p_deathrunes"] = true,
          ["v_keybind"] = "<keybind>",
          ["b_checkothercd"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "123693",
          ["b_t_needsdebuff"] = true,
          ["v_checkothercdvalue"] = "<1",
          ["v_actionicon"] = "123693",
          ["v_checkothercdname"] = "77575",
        },
        ["defaultRotation/deathKnight/BloodTap_Blood"] = {
          ["b_p_bloodrunes"] = true,
          ["v_gcdspell"] = "0",
          ["v_p_havebuff"] = "_114851#5",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "45529",
          ["v_spellname"] = "45529",
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
          ["v_p_bloodrunes"] = "=0",
          ["b_p_havebuff"] = true,
        },
        ["defaultRotation/deathKnight/FrostPresence"] = {
          ["v_p_notstance"] = "2",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "48266",
          ["v_spellname"] = "48266",
          ["b_p_notstance"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "111673",
          ["v_durationstartedtime"] = 0,
        },
        ["defaultRotation/deathKnight/FrostStrike_Machine"] = {
          ["v_gcdspell"] = "111673",
          ["b_rangecheck"] = true,
          ["b_t_hasdebuff"] = true,
          ["b_p_havebuff"] = true,
          ["v_p_unitpower"] = ">=20",
          ["v_rangespell"] = "49020",
          ["b_p_unitpower"] = true,
          ["v_actionicon"] = "49143",
          ["v_togglename"] = "Toggle 1",
          ["v_p_unitpowertype"] = "6",
          ["v_spellname"] = "49143",
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_51124",
          ["v_t_hasdebuff"] = "_55095^2&_55078^2",
        },
        ["defaultRotation/deathKnight/HowlingBlast_Fever"] = {
          ["v_t_needsdebuff"] = "_55095",
          ["b_p_frostrunes"] = true,
          ["v_keybind"] = "<keybind>",
          ["b_p_unholyrunes"] = true,
          ["b_rangecheck"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_gcdspell"] = "111673",
          ["v_p_frostrunes"] = ">=1",
          ["b_checkothercd"] = true,
          ["v_p_unholyrunes"] = ">=1",
          ["v_actionicon"] = "49184",
          ["v_spellname"] = "49184",
          ["b_t_needsdebuff"] = true,
          ["v_checkothercdvalue"] = ">5",
          ["v_durationstartedtime"] = 0,
          ["v_checkothercdname"] = "77575",
        },
        ["defaultRotation/deathKnight/conversion"] = {
          ["v_p_needbuff"] = "_119975",
          ["b_p_needbuff"] = true,
          ["v_p_hp"] = "<70%",
          ["v_actionicon"] = "119975",
          ["v_spellname"] = "119975",
          ["v_togglename"] = "Toggle 1",
          ["b_p_hp"] = true,
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
        },
        ["defaultRotation/deathKnight/DeathSiphon"] = {
          ["v_p_deathrunes"] = ">=1",
          ["b_p_deathrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["v_keybind"] = "<keybind>",
          ["v_p_hp"] = "<70%",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "108196",
          ["v_togglename"] = "Toggle 1",
          ["b_p_hp"] = true,
          ["v_actionicon"] = "108196",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/DeathPact"] = {
          ["v_gcdspell"] = "0",
          ["v_keybind"] = "<keybind>",
          ["v_pet_hp"] = ">0",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "48743",
          ["v_spellname"] = "48743",
          ["v_p_hp"] = "<35%",
          ["b_p_hp"] = true,
          ["v_durationstartedtime"] = 0,
          ["b_pet_hp"] = true,
        },
        ["defaultRotation/deathKnight/Obliterate"] = {
          ["b_p_frostrunes"] = true,
          ["b_t_hasdebuff"] = true,
          ["b_p_unholyrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["b_rangecheck"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_p_unholyrunes"] = "=2",
          ["v_actionicon"] = "49020",
          ["v_spellname"] = "49020",
          ["v_p_frostrunes"] = ">=1",
          ["v_keybind"] = "<keybind>",
          ["v_durationstartedtime"] = 0,
          ["v_t_hasdebuff"] = "_55095^2&_55078^2",
        },
        ["defaultRotation/deathKnight/FrostStrike_Power"] = {
          ["v_gcdspell"] = "111673",
          ["v_rangespell"] = "49020",
          ["v_actionicon"] = "49143",
          ["b_p_unitpower"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "49143",
          ["v_p_unitpowertype"] = "6",
          ["v_keybind"] = "<keybind>",
          ["v_p_unitpower"] = ">=90",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/PillarOfFrost"] = {
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "51271",
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "0",
          ["v_actionicon"] = "51271",
        },
        ["defaultRotation/deathKnight/Outbreak"] = {
          ["v_t_needsdebuff"] = "_55095&_55078",
          ["v_gcdspell"] = "111673",
          ["v_keybind"] = "<keybind>",
          ["v_togglename"] = "Toggle 1",
          ["v_p_knownotspell"] = "59332",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "77575",
          ["b_t_needsdebuff"] = true,
          ["b_p_knownotspell"] = true,
          ["v_actionicon"] = "77575",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/BloodTap_Unholy"] = {
          ["v_gcdspell"] = "0",
          ["b_p_unholyrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_p_unholyrunes"] = "=0",
          ["v_actionicon"] = "45529",
          ["v_spellname"] = "45529",
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_114851#5",
          ["b_p_havebuff"] = true,
        },
        ["defaultRotation/deathKnight/DeathCoil_Lichborn"] = {
          ["b_p_havebuff"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_p_unitpower"] = ">=40",
          ["v_gcdspell"] = "111673",
          ["b_p_unitpower"] = true,
          ["v_actionicon"] = "47541",
          ["v_p_hp"] = "<100%",
          ["v_p_unitpowertype"] = "6",
          ["v_spellname"] = "47541",
          ["v_durationstartedtime"] = 0,
          ["b_p_hp"] = true,
          ["v_p_havebuff"] = "_49039",
          ["v_keybind"] = "<keybind>",
        },
        ["defaultRotation/deathKnight/Outbreak_Glyph"] = {
          ["v_t_needsdebuff"] = "_55095&_55078",
          ["v_p_unitpowertype"] = "6",
          ["v_p_knowspell"] = "59332",
          ["b_p_unitpower"] = true,
          ["v_gcdspell"] = "111673",
          ["v_actionicon"] = "77575",
          ["b_p_knowspell"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "77575",
          ["b_t_needsdebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_p_unitpower"] = ">=40",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/SoulReaper_Death"] = {
          ["v_p_deathrunes"] = ">=1",
          ["b_p_deathrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["b_rangecheck"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "130735",
          ["b_t_hp"] = true,
          ["v_spellname"] = "130735",
          ["v_keybind"] = "<keybind>",
          ["v_durationstartedtime"] = 0,
          ["v_t_hp"] = "<=35%",
        },
        ["defaultRotation/deathKnight/RaiseDead"] = {
          ["v_gcdspell"] = "111673",
          ["v_keybind"] = "<keybind>",
          ["v_pet_hp"] = "=0",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "46584",
          ["v_spellname"] = "46584",
          ["v_p_hp"] = "<35%",
          ["b_p_hp"] = true,
          ["v_durationstartedtime"] = 0,
          ["b_pet_hp"] = true,
        },
        ["defaultRotation/deathKnight/horn_of_winter_power"] = {
          ["v_gcdspell"] = "111673",
          ["b_p_unitpower"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "57330",
          ["v_p_unitpowertype"] = "6",
          ["v_keybind"] = "<keybind>",
          ["v_p_unitpower"] = "<90",
          ["v_actionicon"] = "57330",
        },
        ["defaultRotation/deathKnight/FrostStrike"] = {
          ["v_gcdspell"] = "111673",
          ["v_rangespell"] = "49020",
          ["v_actionicon"] = "49143",
          ["b_p_unitpower"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "49143",
          ["v_p_unitpowertype"] = "6",
          ["v_keybind"] = "<keybind>",
          ["v_p_unitpower"] = ">=20",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/Obliterate_Death"] = {
          ["v_p_deathrunes"] = ">=1",
          ["b_t_hasdebuff"] = true,
          ["v_gcdspell"] = "111673",
          ["b_p_deathrunes"] = true,
          ["b_p_unholyrunes"] = true,
          ["b_rangecheck"] = true,
          ["v_p_unholyrunes"] = "=2",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "49020",
          ["v_togglename"] = "Toggle 1",
          ["v_keybind"] = "<keybind>",
          ["v_actionicon"] = "49020",
          ["v_t_hasdebuff"] = "_55095^2&_55078^2",
        },
        ["defaultRotation/deathKnight/EmpowerRuneWeapon"] = {
          ["b_p_frostrunes"] = true,
          ["v_p_deathrunes"] = "=0",
          ["v_gcdspell"] = "0",
          ["b_p_unholyrunes"] = true,
          ["b_p_deathrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["b_p_bloodrunes"] = true,
          ["v_p_unholyrunes"] = "=0",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "47568",
          ["v_p_frostrunes"] = "=0",
          ["v_keybind"] = "<keybind>",
          ["v_p_bloodrunes"] = "=0",
          ["v_actionicon"] = "47568",
        },
        ["defaultRotation/deathKnight/BloodTap_Frost"] = {
          ["b_p_frostrunes"] = true,
          ["v_gcdspell"] = "0",
          ["b_p_havebuff"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "45529",
          ["v_spellname"] = "45529",
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_114851#5",
          ["v_p_frostrunes"] = "=0",
        },
      },
      ["SortedActions"] = {
        "defaultRotation/deathKnight/DeathCoil_Lichborn", -- [1]
        "defaultRotation/deathKnight/FrostPresence", -- [2]
        "defaultRotation/deathKnight/horn_of_winter", -- [3]
        "defaultRotation/deathKnight/RaiseDead", -- [4]
        "defaultRotation/deathKnight/DeathPact", -- [5]
        "defaultRotation/deathKnight/EmpowerRuneWeapon", -- [6]
        "defaultRotation/deathKnight/Lichborne", -- [7]
        "defaultRotation/deathKnight/conversion", -- [8]
        "defaultRotation/deathKnight/BloodTap_Blood", -- [9]
        "defaultRotation/deathKnight/BloodTap_Frost", -- [10]
        "defaultRotation/deathKnight/BloodTap_Unholy", -- [11]
        "defaultRotation/deathKnight/PillarOfFrost", -- [12]
        "defaultRotation/deathKnight/SoulReaper_Frost", -- [13]
        "defaultRotation/deathKnight/SoulReaper_Death", -- [14]
        "defaultRotation/deathKnight/unholy_blight", -- [15]
        "defaultRotation/deathKnight/Outbreak", -- [16]
        "defaultRotation/deathKnight/Outbreak_Glyph", -- [17]
        "defaultRotation/deathKnight/PlagueLeech_Frost", -- [18]
        "defaultRotation/deathKnight/PlagueLeech_Unholy", -- [19]
        "defaultRotation/deathKnight/PlagueLeech_Death", -- [20]
        "defaultRotation/deathKnight/HowlingBlast_Fever", -- [21]
        "defaultRotation/deathKnight/Plague_Strike", -- [22]
        "defaultRotation/deathKnight/FrostStrike_Machine", -- [23]
        "defaultRotation/deathKnight/DeathAndDecay", -- [24]
        "defaultRotation/deathKnight/Obliterate_Machine", -- [25]
        "defaultRotation/deathKnight/Obliterate_Machine_Death", -- [26]
        "defaultRotation/deathKnight/FrostStrike_Power", -- [27]
        "defaultRotation/deathKnight/HowlingBlast_Rime", -- [28]
        "defaultRotation/deathKnight/DeathSiphon", -- [29]
        "defaultRotation/deathKnight/Obliterate", -- [30]
        "defaultRotation/deathKnight/Obliterate_Death", -- [31]
        "defaultRotation/deathKnight/FrostStrike", -- [32]
        "defaultRotation/deathKnight/HowlingBlast", -- [33]
        "defaultRotation/deathKnight/HowlingBlast_Death", -- [34]
        "defaultRotation/deathKnight/horn_of_winter_power", -- [35]
      },
      ["keybind"] = "<keybind>",
    },
    ["defaultRotation/deathKnight/frost_2_handed"] = {
      ["ActionList"] = {
        ["defaultRotation/deathKnight/unholy_blight"] = {
          ["v_t_needsdebuff"] = "_55095&_55078",
          ["b_t_dr"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "115989",
          ["b_t_needsdebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "111673",
          ["v_actionicon"] = "115989",
        },
        ["defaultRotation/deathKnight/FrostPresence"] = {
          ["v_p_notstance"] = "2",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "48266",
          ["v_spellname"] = "48266",
          ["b_p_notstance"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "111673",
          ["v_durationstartedtime"] = 0,
        },
        ["defaultRotation/deathKnight/HowlingBlast_Rime"] = {
          ["v_gcdspell"] = "111673",
          ["v_durationstartedtime"] = 0,
          ["v_togglename"] = "Toggle 1",
          ["b_p_havebuff"] = true,
          ["v_spellname"] = "49184",
          ["v_actionicon"] = "49184",
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_59052",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/PlagueLeech_Unholy"] = {
          ["v_t_needsdebuff"] = "_55095^4&_55078^4",
          ["v_gcdspell"] = "111673",
          ["v_p_deathrunes"] = "<6",
          ["b_p_unholyrunes"] = true,
          ["b_rangecheck"] = true,
          ["v_togglename"] = "Toggle 1",
          ["b_p_deathrunes"] = true,
          ["v_keybind"] = "<keybind>",
          ["b_checkothercd"] = true,
          ["v_p_unholyrunes"] = "=0",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "123693",
          ["b_t_needsdebuff"] = true,
          ["v_checkothercdvalue"] = "<1",
          ["v_actionicon"] = "123693",
          ["v_checkothercdname"] = "77575",
        },
        ["defaultRotation/deathKnight/HowlingBlast_Fever"] = {
          ["v_t_needsdebuff"] = "_55095",
          ["b_p_frostrunes"] = true,
          ["v_keybind"] = "<keybind>",
          ["b_p_unholyrunes"] = true,
          ["b_rangecheck"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_gcdspell"] = "111673",
          ["v_p_frostrunes"] = ">=1",
          ["b_checkothercd"] = true,
          ["v_p_unholyrunes"] = ">=1",
          ["v_actionicon"] = "49184",
          ["v_spellname"] = "49184",
          ["b_t_needsdebuff"] = true,
          ["v_checkothercdvalue"] = ">5",
          ["v_durationstartedtime"] = 0,
          ["v_checkothercdname"] = "77575",
        },
        ["defaultRotation/deathKnight/horn_of_winter"] = {
          ["v_p_needbuff"] = "57330|19506|6673",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "57330",
          ["v_spellname"] = "57330",
          ["b_p_needbuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "111673",
          ["v_durationstartedtime"] = 0,
        },
        ["defaultRotation/deathKnight/conversion"] = {
          ["v_p_needbuff"] = "_119975",
          ["b_p_needbuff"] = true,
          ["v_p_hp"] = "<70%",
          ["v_actionicon"] = "119975",
          ["v_spellname"] = "119975",
          ["v_togglename"] = "Toggle 1",
          ["b_p_hp"] = true,
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
        },
        ["defaultRotation/deathKnight/DeathSiphon"] = {
          ["v_p_deathrunes"] = ">=1",
          ["b_p_deathrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["v_keybind"] = "<keybind>",
          ["v_p_hp"] = "<70%",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "108196",
          ["v_togglename"] = "Toggle 1",
          ["b_p_hp"] = true,
          ["v_actionicon"] = "108196",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/Lichborne"] = {
          ["v_actionicon"] = "49039",
          ["v_p_hp"] = "<50%",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "49039",
          ["v_togglename"] = "Toggle 1",
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "0",
          ["b_p_hp"] = true,
        },
        ["defaultRotation/deathKnight/DeathPact"] = {
          ["v_gcdspell"] = "0",
          ["v_keybind"] = "<keybind>",
          ["v_pet_hp"] = ">0",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "48743",
          ["v_spellname"] = "48743",
          ["v_p_hp"] = "<35%",
          ["b_p_hp"] = true,
          ["v_durationstartedtime"] = 0,
          ["b_pet_hp"] = true,
        },
        ["defaultRotation/deathKnight/EmpowerRuneWeapon"] = {
          ["b_p_frostrunes"] = true,
          ["v_p_deathrunes"] = "=0",
          ["v_gcdspell"] = "0",
          ["b_p_unholyrunes"] = true,
          ["b_p_deathrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["b_p_bloodrunes"] = true,
          ["v_p_unholyrunes"] = "=0",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "47568",
          ["v_p_frostrunes"] = "=0",
          ["v_keybind"] = "<keybind>",
          ["v_p_bloodrunes"] = "=0",
          ["v_actionicon"] = "47568",
        },
        ["defaultRotation/deathKnight/FrostStrike_Power"] = {
          ["v_gcdspell"] = "111673",
          ["v_rangespell"] = "49020",
          ["v_actionicon"] = "49143",
          ["b_p_unitpower"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "49143",
          ["v_p_unitpowertype"] = "6",
          ["v_keybind"] = "<keybind>",
          ["v_p_unitpower"] = ">=90",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/horn_of_winter_power"] = {
          ["v_gcdspell"] = "111673",
          ["b_p_unitpower"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "57330",
          ["v_p_unitpowertype"] = "6",
          ["v_keybind"] = "<keybind>",
          ["v_p_unitpower"] = "<90",
          ["v_actionicon"] = "57330",
        },
        ["defaultRotation/deathKnight/Obliterate_Machine_Death"] = {
          ["v_p_deathrunes"] = ">=2",
          ["b_t_hasdebuff"] = true,
          ["v_gcdspell"] = "111673",
          ["b_p_deathrunes"] = true,
          ["b_rangecheck"] = true,
          ["v_actionicon"] = "49020",
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "49020",
          ["b_p_havebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_51124",
          ["v_t_hasdebuff"] = "_55095^2&_55078^2",
        },
        ["defaultRotation/deathKnight/Outbreak"] = {
          ["v_t_needsdebuff"] = "_55095&_55078",
          ["v_gcdspell"] = "111673",
          ["v_keybind"] = "<keybind>",
          ["v_togglename"] = "Toggle 1",
          ["v_p_knownotspell"] = "59332",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "77575",
          ["b_t_needsdebuff"] = true,
          ["b_p_knownotspell"] = true,
          ["v_actionicon"] = "77575",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/FrostStrike"] = {
          ["v_gcdspell"] = "111673",
          ["v_rangespell"] = "49020",
          ["v_actionicon"] = "49143",
          ["b_p_unitpower"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "49143",
          ["v_p_unitpowertype"] = "6",
          ["v_keybind"] = "<keybind>",
          ["v_p_unitpower"] = ">=20",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/Obliterate"] = {
          ["b_p_frostrunes"] = true,
          ["b_t_hasdebuff"] = true,
          ["b_p_unholyrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["b_rangecheck"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_p_unholyrunes"] = ">=1",
          ["v_actionicon"] = "49020",
          ["v_spellname"] = "49020",
          ["v_p_frostrunes"] = ">=1",
          ["v_keybind"] = "<keybind>",
          ["v_durationstartedtime"] = 0,
          ["v_t_hasdebuff"] = "_55095^2&_55078^2",
        },
        ["defaultRotation/deathKnight/Obliterate_Machine"] = {
          ["b_p_frostrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["b_t_hasdebuff"] = true,
          ["b_p_unholyrunes"] = true,
          ["b_rangecheck"] = true,
          ["v_gcdspell"] = "111673",
          ["v_durationstartedtime"] = 0,
          ["v_p_frostrunes"] = "=2",
          ["v_p_unholyrunes"] = "=2",
          ["v_actionicon"] = "49020",
          ["v_spellname"] = "49020",
          ["b_p_havebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_51124",
          ["v_t_hasdebuff"] = "_55095^2&_55078^2",
        },
        ["defaultRotation/deathKnight/BloodTap_Unholy"] = {
          ["v_gcdspell"] = "0",
          ["b_p_unholyrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_p_unholyrunes"] = "=0",
          ["v_actionicon"] = "45529",
          ["v_spellname"] = "45529",
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_114851#5",
          ["b_p_havebuff"] = true,
        },
        ["defaultRotation/deathKnight/BloodTap_Frost"] = {
          ["b_p_frostrunes"] = true,
          ["v_gcdspell"] = "0",
          ["b_p_havebuff"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "45529",
          ["v_spellname"] = "45529",
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_114851#5",
          ["v_p_frostrunes"] = "=0",
        },
        ["defaultRotation/deathKnight/PlagueLeech_Frost"] = {
          ["v_t_needsdebuff"] = "_55095^4&_55078^4",
          ["b_p_frostrunes"] = true,
          ["v_p_deathrunes"] = "<6",
          ["v_gcdspell"] = "111673",
          ["b_rangecheck"] = true,
          ["v_p_frostrunes"] = "=0",
          ["b_p_deathrunes"] = true,
          ["v_keybind"] = "<keybind>",
          ["b_checkothercd"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "123693",
          ["b_t_needsdebuff"] = true,
          ["v_checkothercdvalue"] = "<1",
          ["v_actionicon"] = "123693",
          ["v_checkothercdname"] = "77575",
        },
        ["defaultRotation/deathKnight/Plague_Strike"] = {
          ["v_t_needsdebuff"] = "_55078",
          ["v_checkothercdname"] = "77575",
          ["b_p_unholyrunes"] = true,
          ["b_t_hasdebuff"] = true,
          ["b_rangecheck"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_gcdspell"] = "111673",
          ["v_actionicon"] = "45462",
          ["b_checkothercd"] = true,
          ["v_p_unholyrunes"] = ">=1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "45462",
          ["b_t_needsdebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_checkothercdvalue"] = ">5",
          ["v_t_hasdebuff"] = "_55095",
        },
        ["defaultRotation/deathKnight/Outbreak_Glyph"] = {
          ["v_t_needsdebuff"] = "_55095&_55078",
          ["v_p_unitpowertype"] = "6",
          ["v_p_knowspell"] = "59332",
          ["b_p_unitpower"] = true,
          ["v_gcdspell"] = "111673",
          ["v_actionicon"] = "77575",
          ["b_p_knowspell"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "77575",
          ["b_t_needsdebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_p_unitpower"] = ">=40",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/SoulReaper_Death"] = {
          ["v_p_deathrunes"] = ">=1",
          ["b_p_deathrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["b_rangecheck"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "130735",
          ["b_t_hp"] = true,
          ["v_spellname"] = "130735",
          ["v_keybind"] = "<keybind>",
          ["v_durationstartedtime"] = 0,
          ["v_t_hp"] = "<=35%",
        },
        ["defaultRotation/deathKnight/RaiseDead"] = {
          ["v_gcdspell"] = "111673",
          ["v_keybind"] = "<keybind>",
          ["v_pet_hp"] = "=0",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "46584",
          ["v_spellname"] = "46584",
          ["v_p_hp"] = "<35%",
          ["b_p_hp"] = true,
          ["v_durationstartedtime"] = 0,
          ["b_pet_hp"] = true,
        },
        ["defaultRotation/deathKnight/SoulReaper_Frost"] = {
          ["b_p_frostrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["b_rangecheck"] = true,
          ["v_actionicon"] = "130735",
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "130735",
          ["b_t_hp"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_p_frostrunes"] = ">=1",
          ["v_t_hp"] = "<=35%",
        },
        ["defaultRotation/deathKnight/PlagueLeech_Death"] = {
          ["v_t_needsdebuff"] = "_55095^4&_55078^4",
          ["v_p_deathrunes"] = "<2",
          ["v_gcdspell"] = "111673",
          ["b_rangecheck"] = true,
          ["b_p_deathrunes"] = true,
          ["v_keybind"] = "<keybind>",
          ["b_checkothercd"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "123693",
          ["b_t_needsdebuff"] = true,
          ["v_checkothercdvalue"] = "<1",
          ["v_actionicon"] = "123693",
          ["v_checkothercdname"] = "77575",
        },
        ["defaultRotation/deathKnight/DeathCoil_Lichborn"] = {
          ["b_p_havebuff"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_p_unitpower"] = ">=40",
          ["v_gcdspell"] = "111673",
          ["b_p_unitpower"] = true,
          ["v_actionicon"] = "47541",
          ["v_p_hp"] = "<100%",
          ["v_p_unitpowertype"] = "6",
          ["v_spellname"] = "47541",
          ["v_durationstartedtime"] = 0,
          ["b_p_hp"] = true,
          ["v_p_havebuff"] = "_49039",
          ["v_keybind"] = "<keybind>",
        },
        ["defaultRotation/deathKnight/BloodTap_Blood"] = {
          ["b_p_bloodrunes"] = true,
          ["v_gcdspell"] = "0",
          ["v_p_havebuff"] = "_114851#5",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "45529",
          ["v_spellname"] = "45529",
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
          ["v_p_bloodrunes"] = "=0",
          ["b_p_havebuff"] = true,
        },
        ["defaultRotation/deathKnight/PillarOfFrost"] = {
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "51271",
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "0",
          ["v_actionicon"] = "51271",
        },
      },
      ["SortedActions"] = {
        "defaultRotation/deathKnight/DeathCoil_Lichborn", -- [1]
        "defaultRotation/deathKnight/FrostPresence", -- [2]
        "defaultRotation/deathKnight/horn_of_winter", -- [3]
        "defaultRotation/deathKnight/RaiseDead", -- [4]
        "defaultRotation/deathKnight/DeathPact", -- [5]
        "defaultRotation/deathKnight/EmpowerRuneWeapon", -- [6]
        "defaultRotation/deathKnight/Lichborne", -- [7]
        "defaultRotation/deathKnight/conversion", -- [8]
        "defaultRotation/deathKnight/BloodTap_Blood", -- [9]
        "defaultRotation/deathKnight/BloodTap_Frost", -- [10]
        "defaultRotation/deathKnight/BloodTap_Unholy", -- [11]
        "defaultRotation/deathKnight/PillarOfFrost", -- [12]
        "defaultRotation/deathKnight/SoulReaper_Frost", -- [13]
        "defaultRotation/deathKnight/SoulReaper_Death", -- [14]
        "defaultRotation/deathKnight/Obliterate_Machine", -- [15]
        "defaultRotation/deathKnight/Obliterate_Machine_Death", -- [16]
        "defaultRotation/deathKnight/unholy_blight", -- [17]
        "defaultRotation/deathKnight/Outbreak", -- [18]
        "defaultRotation/deathKnight/Outbreak_Glyph", -- [19]
        "defaultRotation/deathKnight/PlagueLeech_Frost", -- [20]
        "defaultRotation/deathKnight/PlagueLeech_Unholy", -- [21]
        "defaultRotation/deathKnight/PlagueLeech_Death", -- [22]
        "defaultRotation/deathKnight/HowlingBlast_Fever", -- [23]
        "defaultRotation/deathKnight/Plague_Strike", -- [24]
        "defaultRotation/deathKnight/FrostStrike_Power", -- [25]
        "defaultRotation/deathKnight/HowlingBlast_Rime", -- [26]
        "defaultRotation/deathKnight/DeathSiphon", -- [27]
        "defaultRotation/deathKnight/Obliterate", -- [28]
        "defaultRotation/deathKnight/FrostStrike", -- [29]
        "defaultRotation/deathKnight/horn_of_winter_power", -- [30]
      },
      ["keybind"] = "<keybind>",
    },
    ["defaultRotation/deathKnight/unholy"] = {
      ["ActionList"] = {
        ["defaultRotation/deathKnight/unholy_blight"] = {
          ["v_t_needsdebuff"] = "_55095&_55078",
          ["b_t_dr"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "115989",
          ["b_t_needsdebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "111673",
          ["v_actionicon"] = "115989",
        },
        ["defaultRotation/deathKnight/ScourgeStrike_Death"] = {
          ["v_p_deathrunes"] = ">=1",
          ["b_p_deathrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "55090",
          ["v_spellname"] = "55090",
          ["v_gcdspell"] = "111673",
          ["v_keybind"] = "<keybind>",
          ["v_durationstartedtime"] = 0,
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/SummonGargoyle"] = {
          ["b_p_havebuff"] = true,
          ["v_actionicon"] = "49206",
          ["v_gcdspell"] = "111673",
          ["v_p_unitpower"] = ">60",
          ["b_p_unitpower"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "49206",
          ["v_p_unitpowertype"] = "6",
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "49016",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/PlagueLeech_Unholy"] = {
          ["v_t_needsdebuff"] = "_55095^4&_55078^4",
          ["v_togglename"] = "Toggle 1",
          ["b_p_unholyrunes"] = true,
          ["b_rangecheck"] = true,
          ["v_gcdspell"] = "111673",
          ["v_keybind"] = "<keybind>",
          ["b_checkothercd"] = true,
          ["v_p_unholyrunes"] = "=0",
          ["v_actionicon"] = "123693",
          ["v_spellname"] = "123693",
          ["b_t_needsdebuff"] = true,
          ["v_checkothercdvalue"] = "<1",
          ["v_durationstartedtime"] = 0,
          ["v_checkothercdname"] = "77575",
        },
        ["defaultRotation/deathKnight/horn_of_winter"] = {
          ["v_p_needbuff"] = "57330|19506|6673",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "57330",
          ["v_spellname"] = "57330",
          ["b_p_needbuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "111673",
          ["v_durationstartedtime"] = 0,
        },
        ["defaultRotation/deathKnight/Lichborne"] = {
          ["v_actionicon"] = "49039",
          ["v_p_hp"] = "<50%",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "49039",
          ["v_togglename"] = "Toggle 1",
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "0",
          ["b_p_hp"] = true,
        },
        ["defaultRotation/deathKnight/DeathAndDecay_Unholy"] = {
          ["v_togglename"] = "Toggle 1",
          ["v_p_unholyrunes"] = ">=1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "43265",
          ["b_p_unholyrunes"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "111673",
          ["v_actionicon"] = "43265",
        },
        ["defaultRotation/deathKnight/horn_of_winter_power"] = {
          ["v_gcdspell"] = "111673",
          ["b_p_unitpower"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "57330",
          ["v_p_unitpowertype"] = "6",
          ["v_keybind"] = "<keybind>",
          ["v_p_unitpower"] = "<90",
          ["v_actionicon"] = "57330",
        },
        ["defaultRotation/deathKnight/UnholyPresence"] = {
          ["v_p_notstance"] = "3",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "48265",
          ["v_spellname"] = "48265",
          ["b_p_notstance"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "111673",
          ["v_durationstartedtime"] = 0,
        },
        ["defaultRotation/deathKnight/Plague_Strike"] = {
          ["v_t_needsdebuff"] = "_55078",
          ["v_checkothercdname"] = "77575",
          ["b_p_unholyrunes"] = true,
          ["b_t_hasdebuff"] = true,
          ["b_rangecheck"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_gcdspell"] = "111673",
          ["v_actionicon"] = "45462",
          ["b_checkothercd"] = true,
          ["v_p_unholyrunes"] = ">=1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "45462",
          ["b_t_needsdebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_checkothercdvalue"] = ">5",
          ["v_t_hasdebuff"] = "_55095",
        },
        ["defaultRotation/deathKnight/IcyTouch"] = {
          ["v_t_needsdebuff"] = "_55095",
          ["b_p_frostrunes"] = true,
          ["v_keybind"] = "<keybind>",
          ["b_p_unholyrunes"] = true,
          ["b_rangecheck"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_gcdspell"] = "111673",
          ["v_p_frostrunes"] = ">=1",
          ["b_checkothercd"] = true,
          ["v_p_unholyrunes"] = ">=1",
          ["v_actionicon"] = "45477",
          ["v_spellname"] = "45477",
          ["b_t_needsdebuff"] = true,
          ["v_checkothercdvalue"] = ">5",
          ["v_durationstartedtime"] = 0,
          ["v_checkothercdname"] = "77575",
        },
        ["defaultRotation/deathKnight/BloodTap_Blood"] = {
          ["b_p_bloodrunes"] = true,
          ["v_gcdspell"] = "0",
          ["v_p_havebuff"] = "_114851#5",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "45529",
          ["v_spellname"] = "45529",
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
          ["v_p_bloodrunes"] = "=0",
          ["b_p_havebuff"] = true,
        },
        ["defaultRotation/deathKnight/conversion"] = {
          ["v_p_needbuff"] = "_119975",
          ["b_p_needbuff"] = true,
          ["v_p_hp"] = "<70%",
          ["v_actionicon"] = "119975",
          ["v_spellname"] = "119975",
          ["v_togglename"] = "Toggle 1",
          ["b_p_hp"] = true,
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
        },
        ["defaultRotation/deathKnight/DeathSiphon"] = {
          ["v_p_deathrunes"] = ">=1",
          ["b_p_deathrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["v_keybind"] = "<keybind>",
          ["v_p_hp"] = "<70%",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "108196",
          ["v_togglename"] = "Toggle 1",
          ["b_p_hp"] = true,
          ["v_actionicon"] = "108196",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/DeathCoil_Power"] = {
          ["v_gcdspell"] = "111673",
          ["v_actionicon"] = "47541",
          ["b_p_unitpower"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "47541",
          ["v_p_unitpowertype"] = "6",
          ["v_keybind"] = "<keybind>",
          ["v_p_unitpower"] = ">=90",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/EmpowerRuneWeapon"] = {
          ["b_p_frostrunes"] = true,
          ["v_p_deathrunes"] = "=0",
          ["v_gcdspell"] = "0",
          ["b_p_unholyrunes"] = true,
          ["b_p_deathrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["b_p_bloodrunes"] = true,
          ["v_p_unholyrunes"] = "=0",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "47568",
          ["v_p_frostrunes"] = "=0",
          ["v_keybind"] = "<keybind>",
          ["v_p_bloodrunes"] = "=0",
          ["v_actionicon"] = "47568",
        },
        ["defaultRotation/deathKnight/DeathAndDecay_Death"] = {
          ["v_gcdspell"] = "111673",
          ["v_togglename"] = "Toggle 1",
          ["v_p_deathrunes"] = ">=1",
          ["v_spellname"] = "43265",
          ["v_actionicon"] = "43265",
          ["v_keybind"] = "<keybind>",
          ["b_p_deathrunes"] = true,
          ["v_durationstartedtime"] = 0,
        },
        ["defaultRotation/deathKnight/Outbreak"] = {
          ["v_t_needsdebuff"] = "_55095&_55078",
          ["v_gcdspell"] = "111673",
          ["v_keybind"] = "<keybind>",
          ["v_togglename"] = "Toggle 1",
          ["v_p_knownotspell"] = "59332",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "77575",
          ["b_t_needsdebuff"] = true,
          ["b_p_knownotspell"] = true,
          ["v_actionicon"] = "77575",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/DarkTransformation_Death"] = {
          ["v_pet_hasbuff"] = "91342#5",
          ["v_p_deathrunes"] = ">=1",
          ["b_pet_hasbuff"] = true,
          ["b_p_deathrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "63560",
          ["v_gcdspell"] = "111673",
          ["v_keybind"] = "<keybind>",
          ["v_actionicon"] = "63560",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/DeathCoil_Lichborn"] = {
          ["b_p_havebuff"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_p_unitpower"] = ">=32",
          ["v_gcdspell"] = "111673",
          ["b_p_unitpower"] = true,
          ["v_actionicon"] = "47541",
          ["v_p_hp"] = "<100%",
          ["v_p_unitpowertype"] = "6",
          ["v_spellname"] = "47541",
          ["v_durationstartedtime"] = 0,
          ["b_p_hp"] = true,
          ["v_p_havebuff"] = "_49039",
          ["v_keybind"] = "<keybind>",
        },
        ["defaultRotation/deathKnight/BloodTap_Unholy"] = {
          ["v_gcdspell"] = "0",
          ["b_p_unholyrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_p_unholyrunes"] = "=0",
          ["v_actionicon"] = "45529",
          ["v_spellname"] = "45529",
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_114851#5",
          ["b_p_havebuff"] = true,
        },
        ["defaultRotation/deathKnight/DarkTransformation"] = {
          ["v_pet_hasbuff"] = "91342#5",
          ["b_pet_hasbuff"] = true,
          ["v_gcdspell"] = "111673",
          ["b_p_unholyrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "63560",
          ["v_actionicon"] = "63560",
          ["v_keybind"] = "<keybind>",
          ["v_p_unholyrunes"] = ">=1",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/FesteringStrike"] = {
          ["b_p_frostrunes"] = true,
          ["b_p_bloodrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["v_p_frostrunes"] = ">=1",
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "85948",
          ["v_spellname"] = "85948",
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
          ["v_p_bloodrunes"] = ">=1",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/DeathPact"] = {
          ["v_actionicon"] = "48743",
          ["v_p_hp"] = "<35%",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "48743",
          ["v_togglename"] = "Toggle 1",
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "0",
          ["b_p_hp"] = true,
        },
        ["defaultRotation/deathKnight/BloodTap_Frost"] = {
          ["b_p_frostrunes"] = true,
          ["v_gcdspell"] = "0",
          ["b_p_havebuff"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "45529",
          ["v_spellname"] = "45529",
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_114851#5",
          ["v_p_frostrunes"] = "=0",
        },
        ["defaultRotation/deathKnight/SoulReaper_Death"] = {
          ["v_p_deathrunes"] = ">=1",
          ["b_p_deathrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["b_rangecheck"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "130736",
          ["b_t_hp"] = true,
          ["v_spellname"] = "130736",
          ["v_keybind"] = "<keybind>",
          ["v_durationstartedtime"] = 0,
          ["v_t_hp"] = "<=35%",
        },
        ["defaultRotation/deathKnight/PlagueLeech_Blood_Frost"] = {
          ["v_t_needsdebuff"] = "_55095^4&_55078^4",
          ["b_p_frostrunes"] = true,
          ["b_p_bloodrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "123693",
          ["b_t_needsdebuff"] = true,
          ["v_checkothercdvalue"] = "<1",
          ["v_p_bloodrunes"] = "=0",
          ["v_checkothercdname"] = "77575",
          ["b_p_deathrunes"] = true,
          ["b_checkothercd"] = true,
          ["v_actionicon"] = "123693",
          ["b_rangecheck"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_p_deathrunes"] = "<4",
          ["v_p_frostrunes"] = "=0",
        },
        ["defaultRotation/deathKnight/RaiseDead"] = {
          ["v_pet_hp"] = "=0",
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "46584",
          ["v_actionicon"] = "46584",
          ["v_keybind"] = "<keybind>",
          ["v_gcdspell"] = "111673",
          ["b_pet_hp"] = true,
        },
        ["defaultRotation/deathKnight/SoulReaper_Unholy"] = {
          ["b_p_unholyrunes"] = true,
          ["v_gcdspell"] = "111673",
          ["b_rangecheck"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_p_unholyrunes"] = ">=1",
          ["v_actionicon"] = "130736",
          ["v_spellname"] = "130736",
          ["v_durationstartedtime"] = 0,
          ["v_keybind"] = "<keybind>",
          ["b_t_hp"] = true,
          ["v_t_hp"] = "<=35%",
        },
        ["defaultRotation/deathKnight/ScourgeStrike_Unholy"] = {
          ["v_gcdspell"] = "111673",
          ["b_p_unholyrunes"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_actionicon"] = "55090",
          ["v_spellname"] = "55090",
          ["v_p_unholyrunes"] = ">=1",
          ["v_keybind"] = "<keybind>",
          ["v_durationstartedtime"] = 0,
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/Outbreak_Glyph"] = {
          ["v_t_needsdebuff"] = "_55095&_55078",
          ["v_p_unitpowertype"] = "6",
          ["v_p_knowspell"] = "59332",
          ["b_p_unitpower"] = true,
          ["v_gcdspell"] = "111673",
          ["v_actionicon"] = "77575",
          ["b_p_knowspell"] = true,
          ["v_togglename"] = "Toggle 1",
          ["v_durationstartedtime"] = 0,
          ["v_spellname"] = "77575",
          ["b_t_needsdebuff"] = true,
          ["v_keybind"] = "<keybind>",
          ["v_p_unitpower"] = ">=40",
          ["b_rangecheck"] = true,
        },
        ["defaultRotation/deathKnight/DeathCoil"] = {
          ["v_gcdspell"] = "111673",
          ["v_durationstartedtime"] = 0,
          ["v_togglename"] = "Toggle 1",
          ["b_p_havebuff"] = true,
          ["v_spellname"] = "47541",
          ["v_actionicon"] = "47541",
          ["v_keybind"] = "<keybind>",
          ["v_p_havebuff"] = "_81340",
          ["b_rangecheck"] = true,
        },
      },
      ["SortedActions"] = {
        "defaultRotation/deathKnight/DeathCoil_Lichborn", -- [1]
        "defaultRotation/deathKnight/UnholyPresence", -- [2]
        "defaultRotation/deathKnight/horn_of_winter", -- [3]
        "defaultRotation/deathKnight/RaiseDead", -- [4]
        "defaultRotation/deathKnight/DeathPact", -- [5]
        "defaultRotation/deathKnight/EmpowerRuneWeapon", -- [6]
        "defaultRotation/deathKnight/Lichborne", -- [7]
        "defaultRotation/deathKnight/conversion", -- [8]
        "defaultRotation/deathKnight/SummonGargoyle", -- [10]
        "defaultRotation/deathKnight/BloodTap_Blood", -- [11]
        "defaultRotation/deathKnight/BloodTap_Frost", -- [12]
        "defaultRotation/deathKnight/BloodTap_Unholy", -- [13]
        "defaultRotation/deathKnight/unholy_blight", -- [14]
        "defaultRotation/deathKnight/Outbreak", -- [15]
        "defaultRotation/deathKnight/Outbreak_Glyph", -- [16]
        "defaultRotation/deathKnight/PlagueLeech_Blood_Frost", -- [17]
        "defaultRotation/deathKnight/PlagueLeech_Unholy", -- [18]
        "defaultRotation/deathKnight/IcyTouch", -- [19]
        "defaultRotation/deathKnight/Plague_Strike", -- [20]
        "defaultRotation/deathKnight/DarkTransformation", -- [21]
        "defaultRotation/deathKnight/DarkTransformation_Death", -- [22]
        "defaultRotation/deathKnight/SoulReaper_Unholy", -- [23]
        "defaultRotation/deathKnight/SoulReaper_Death", -- [24]
        "defaultRotation/deathKnight/DeathCoil_Power", -- [25]
        "defaultRotation/deathKnight/DeathCoil", -- [26]
        "defaultRotation/deathKnight/DeathAndDecay_Unholy", -- [27]
        "defaultRotation/deathKnight/DeathAndDecay_Death", -- [28]
        "defaultRotation/deathKnight/DeathSiphon", -- [29]
        "defaultRotation/deathKnight/ScourgeStrike_Unholy", -- [30]
        "defaultRotation/deathKnight/ScourgeStrike_Death", -- [31]
        "defaultRotation/deathKnight/FesteringStrike", -- [32]
        "defaultRotation/deathKnight/horn_of_winter_power", -- [33]
      },
      ["keybind"] = "<keybind>",
    },
  }

  -- Restore the true state of the saved data.
  --  return RotationBuilder:restoreTable({}, rotation);
  return rotation;
end

local deathKnightRotationsGeneratorData = {
  ["version"] = 1, 
  ["generator"] = deathKnightRotationsGenerator
};

RotationBuilder:addDefaultRotationsGenerator("DEATHKNIGHT", deathKnightRotationsGeneratorData);